'show checkboxes
'check all
'uncheck all
'display list of checked

'Clipboard Reset
'Clipboard Set Text temp$
'Clipboard Get Text to temp$


'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gblittletemplate.exe"
#Dim All
%Unicode = 1
#Include "Win32API.inc"
#Include "RichEdit.inc"
#Include "WinInet.inc"
#Include "files\gdiplus_simple.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "images\logo.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xchoicea "images\choicea.ico"
#Resource Icon xchoiceb "images\choiceb.ico"
#Resource Icon xfont "images\font.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xfolder "images\folder.ico"
#Resource Icon xfile "images\file.ico"
#Resource Icon xcopy "images\copy.ico"
#Resource Icon xexclaim "images\exclamation.ico"
#Resource Bitmap xface "images\face.bmp"
#Resource Bitmap xgirl "images\cowgirl.bmp"

Declare Function AtlAxWinInit Lib "ATL.DLL" Alias "AtlAxWinInit" () As Long
Declare Function AtlAxWinTerm () As Long
Declare Function AtlAxGetControl Lib "ATL.DLL" Alias "AtlAxGetControl" ( ByVal hWnd As Dword, ByRef pp As Dword ) As Dword

Enum Equates Singular
   IDC_Toolbar
   IDC_ListView
   IDC_TreeView
   IDC_StatusBar
   IDC_Browser
   IDC_Splitter
   IDC_LabelWait
   IDC_RichEdit
   IDC_Graphic
   IDC_Draw

   IDT_Open
   IDT_ChoiceA
   IDT_ChoiceB
   IDT_Font
   IDT_Settings
   IDT_Help

   IDM_Debug
   IDM_Sep
   IDM_Search
   IDM_Info
   IDM_AutoSave
   IDM_Copy
   IDM_Save
   IDM_SaveAs

   IDM_Choice1
   IDM_Choice2
   IDM_Choice3

   IDM_ClearListView
   IDM_LoadListView

   IDM_ShowCheckBoxes
   IDM_CheckAll
   IDM_UnCheckAll
   IDM_DisplayChecked

   IDM_ViewFile
   IDM_OpenFile
   IDM_SaveFile
   IDM_OpenFolder
   IDM_OpenDOS

   IDM_SysTray
   IDM_ExitTray
   IDM_Restore

   IDS_Label
   IDS_Backward
   IDS_Forward
   IDS_SearchTerm
   IDS_SearchSensitive

   Choice1
   Choice2
   Choice3

   TextFile
   ImageFile
   HTMLFile
   OtherFile
End Enum

%UniqueNumber = 1717171717
%WM_Tray  = %WM_User + 1

Type CustomType
   desc As WStringZ * %Max_Path
   val As Long
End Type

Global hDlg,hToolbar,hListView,hTreeView,hRichEdit As Dword                     'handles
Global hPopupTray, ghHook,hFont,hDebug,hSearch As Dword                         'handles
Global hPopupListView,hPopupTreeView,hPopupSettings,hWait,hOCX As Dword         'handles
Global SearchTerm, FontName, FileName, TextFilter As WStringZ * %Max_Path       'INI variables
Global HTMLFilter, ImageFilter As WStringZ * %Max_Path                          'INI variables
Global CaseSensitive, FontSize, FontAttr, SortDirection, LastSelected As Long   'INI variables
Global AutoSave, Choice, ChoiceA, ChoiceB, SysTray,SHowCheckBoxes As Long       'INI variables
Global VBartop, SplitVInWork, SortInWork As Long                                'Splitter varaibles
Global Debug As Long, tn As NotifyIconData                                      'Junk variables
Global D() As CustomType, oOCX As Dispatch                                      'Junk variables


Function PBMain() As Long
   If InstanceTest Then Exit Function
   Dialog New Pixels, 0, "gbLittleTemplate",300,300,200,200, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logo"
   Control Add Label, hDlg, %IDC_Splitter, "",  0,200, 200, 6, %SS_Notify , %WS_Ex_ClientEdge   ' left/right - does vertical split
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local temp$, w,h,iResult As Long, LVData As NM_ListView, pt As Point
   Local nmtb As TBNotify Ptr, rc As Rect, P As TooltipText Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildAcceleratorTable
         CreateSubFolders
         CreateToolbar
         CreateTreeView
         CreateListView
         CreateOCX
         CreateGraphicControls
         CreateRichEditControl
         CreateContextMenus
         InitializeTray
         Settings_INI "get"
         SetMenusAndToolbar
         Font New FontName, FontSize, FontAttr To hFont
         SetControlFonts
         PostMessage hDlg, %WM_User + 500, 0, 0

      Case %WM_User + 500
         ListView Visible hDlg, %IDC_ListView, LastSelected

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_ChoiceA
               ChoiceA = 1
               ChoiceB = 0

            Case %IDT_ChoiceB
               ChoiceA = 0
               ChoiceB = 1

            Case %IDT_Font
               SelectMainFont
               SetControlFonts
               ResizeWindow(1)

            Case %IDT_Settings
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               MessageBox(0, "Information", "Settings", %MB_Ok + %MB_IconInformation)

            Case %IDM_SysTray
               SysTray = SysTray Xor 1
               SetMenusAndToolbar
               ManageSystemTray

           Case %IDM_OpenFolder
              temp$ = PathName$(Path, FileName)
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

           Case %IDM_OpenDOS
              temp$ = PathName$(Path, FileName)
              Shell "cmd /K chdir /D " & temp$        'WinNT, 2000, XP, Vista

            Case %IDM_ViewFile
               iResult  = Shell ("Notepad " + Exe.Path$ + "tem", 1)  'opens Notepad, does not wait for it to close

            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbcatalog.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_Choice1 : Choice = %Choice1 : SetMenusAndToolbar
            Case %IDM_Choice2 : Choice = %Choice2 : SetMenusAndToolbar
            Case %IDM_Choice3 : Choice = %Choice3 : SetMenusAndToolbar

            Case %IDM_ShowCheckBoxes
               ShowCheckBoxes = ShowCheckBoxes Xor 1
               ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect _
                                Or %LVS_Ex_DoubleBuffer Or IIf(ShowCheckBoxes,%LVS_Ex_CheckBoxes, 0)
               ListView Set Column hDlg, %IDC_ListView, 1, 50 + ShowCheckBoxes * 30
               ResizeWindow(1)
               SetMenusAndToolbar

            Case %IDM_CheckAll   :  CheckAll(1)
            Case %IDM_UncheckAll :  CheckAll(0)
            Case %IDM_Debug
               Debug = Debug Xor 1
               If Debug Then
                  Txt.Window "Debug", 300,300,40,40 To hDebug
                  Txt.Print "Window Initialized"
                  Control Set Focus hDlg, %IDC_ListView
               Else
                  Txt.End
               End If

         End Select

      Case %WM_Size
         ResizeWindow 1

      Case %WM_Destroy
         Settings_ini "save"
         DestroyOCX

      Case %WM_Tray
         Select Case Cb.LParam
            Case %WM_RButtonDown
               Menu Set Text hPopupTray, ByCmd %IDM_Restore, "Restore"
               Menu Set Text hPopupTray, ByCmd %IDM_ExitTray, "Exit"
               GetCursorPos pt
               TrackPopupMenu hPopupTray, %TPM_BottomAlign Or %TPM_RightAlign, pt.x, pt.y, 0, hDlg, ByVal %null
               PostMessage hDlg, %WM_Null, 0, 0
            Case %WM_LButtonDblClk
               SysTray = SysTray Xor 1
               SetMenusAndToolbar
               ManageSystemTray
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Open To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
               Case %IDC_ListView
                  Select Case Cb.NmCode
                     Case %NM_Click
                        ShowSelectedFile
                     Case %LVN_ItemChanged
                     Case %NM_DblClk
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                        MessageBox (0, (D(iResult).desc), "Application Information", %MB_Ok + %MB_IconInformation)
                     Case %LVN_ColumnClick
                        Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                        SortDirection = SortDirection Xor 1
                        If SortDirection Then
                           If LVData.iSubItem+1 = 1 Then ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Ascend : Array Sort D(0), Ascend
                        Else
                           If LVData.iSubItem+1 = 1 Then ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Descend : Array Sort D(0), Descend
                        End If
                        ListView Select hDlg, %IDC_ListView, 1
                  End Select
               Case %IDC_TreeView
                  Select Case Cb.NmCode
                     Case %TVN_ItemExpanding
                        Local N As NM_TreeView Ptr
                        N = Cb.LParam
                        DisplayChildren @N.ItemNew.hItem
                     Case %TVN_SelChanged
                        DisplayFilesInListView
                  End Select
         End Select

        Case %WM_ContextMenu
         w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
         iResult = GetDlgCtrlID (Cb.WParam)             'get control ID
         Select Case iResult
            Case %IDC_ListView
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then TrackPopupMenu hPopupListView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
         End Select

      Case %WM_SetCursor
         iResult = GetDlgCtrlID (Cb.WParam)  'determine which over which label control mouse was moved
         If iResult = %IDC_Splitter Then MousePtr 7 : Function = 1    '7 = vertical cursor
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               If iResult = %IDC_Splitter Then SplitVInWork = 1 : ResizeWindow(0)
            Case %WM_MouseMove
               'Repositions splitter bars to match mouse position (if position has changed)
               If SplitVInWork Then If MoveBarUpDown Then ResizeWindow(0)
            Case %WM_LButtonUp
               If SplitVInWork Then
                  SplitVInWork = 0    'sets flags to say splitter action has ended
                  ResizeWindow(1)
               End If
         End Select
   End Select
End Function

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "400", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchTerm", "SearchTerm", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TextFilter", "*.bas;*.txt;", TextFilter, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ImageFilter", "*.bmp;*.gif;*.jpg;*.ico;*.png/*.ico", ImageFilter, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "VBarTop", "200", temp, %Max_Path, INIFileName:  VBarTop = Val(temp)
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "Debug", "0", temp, %Max_Path, INIFileName:  Debug = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "SysTray", "0", temp, %Max_Path, INIFileName:  SysTray = Val(temp)
      Getprivateprofilestring "All", "ShowCheckBoxes", "0", temp, %Max_Path, INIFileName:  ShowCheckBoxes = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      WritePrivateProfileString "All", "TextFilter",TextFilter, INIFileName
      WritePrivateProfileString "All", "ImageFilter",ImageFilter, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "VBarTop", (Str$(VBarTop)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "Debug", (Str$(Debug)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "SysTray", (Str$(SysTray)), INIFileName
      WritePrivateProfileString "All", "ShowCheckBoxes", (Str$(ShowCheckBoxes)), INIFileName
   End If
End Sub

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(3)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd  = %IDM_Debug         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd  = %IDM_Search        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd  = %IDM_Info          : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xopen"      '1
    ImageList Add Icon hImageList, "xchoicea"  '2
    ImageList Add Icon hImageList, "xchoiceb"  '3
    ImageList Add Icon hImageList, "xfont"     '4
    ImageList Add Icon hImageList, "xsettings" '5
    ImageList Add Icon hImageList, "xhelp"     '6

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_ChoiceA,  %TbStyle_CheckGroup, "ChoiceA"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_ChoiceB,  %TbStyle_CheckGroup, "ChoiceB"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Help,  %TbStyle_Button, "Help"

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Display Info", %IDM_Info, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Save On Exit", %IDM_AutoSave, %MF_Enabled
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then Txt.Print FuncName$
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open       : Function = "Open Select File Dialog"
      Case %IDT_Choicea    : Function = "Select ChoiceA"
      Case %IDT_Choiceb    : Function = "Select ChoiceB"
      Case %IDT_Font       : Function = "Open Select Font Dialog  (" + FontName + Str$(FontSize) + ")"
      Case %IDT_Settings   : Function = "Default Settings Button Action"
      Case %IDT_Help       : Function = "Open Online Help"
   End Select
End Function

Sub SelectMainFont
   If Debug Then Txt.Print FuncName$
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub SetMenusAndToolbar
   If Debug Then Txt.Print FuncName$
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ChoiceA, ChoiceA * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ChoiceB, ChoiceB * %TBState_Checked Or %TBState_Enabled

   'Menus
    Menu Set State hPopupTray, ByCmd %IDM_SysTray, Systray * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoSave, AutoSave * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupSettings, ByCmd %IDM_Choice1, 0
    Menu Set State hPopupSettings, ByCmd %IDM_Choice2, 0
    Menu Set State hPopupSettings, ByCmd %IDM_Choice3, 0
    Select Case Choice
       Case %Choice1 : Menu Set State hPopupSettings, ByCmd %IDM_Choice1, %MFS_Checked Or %MFS_Enabled
       Case %Choice2 : Menu Set State hPopupSettings, ByCmd %IDM_Choice2, %MFS_Checked Or %MFS_Enabled
       Case %Choice3 : Menu Set State hPopupSettings, ByCmd %IDM_Choice3, %MFS_Checked Or %MFS_Enabled
    End Select

End Sub

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub DisplayWaitDialog(hParent As Dword, Msg$)
   If Debug Then Txt.Print FuncName$
   Local x As Long, y As Long, w As Long, h As Long, wX As Long, wY As Long
   Dialog Get Client hParent To w,h
   wX = 260 : wY = 80
   x = (w-wX)/2    'gets left position of WaitDialog to center over app
   y = (h-wY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", x, y, wX, wY, %WS_Popup To hWait
   Control Add Label, hWait, %IDC_LabelWait, Msg$ + $CrLf + "   Please wait ... ", 0, 0, wX, wY, %SS_Center Or %SS_CenterImage Or %WS_Border
   Control Set Font hWait, %IDC_LabelWait, hFont
   Control Set Color hWait, %IDC_LabelWait, %Black, %rgb_LightBlue
   Dialog Show Modeless hWait
End Sub

Sub CreateSubFolders
   If Debug Then Txt.Print FuncName$
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "downloads") = %False Then MkDir Exe.Path$ + "downloads"
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then Txt.Print FuncName$
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Function GetURL (URLPath As WStringZ * %Max_Path, LocalPath As WStringZ * %Max_Path) As Long
   If Debug Then Txt.Print FuncName$
   DeleteURLCacheEntry(URLPath)     '1 = success  clear the cache
   If URLDownloadToFile (ByVal 0, URLPath, LocalPath, 0, 0) = 0 Then Function = 1
End Function

Function URLExists(URL As StringZ * %Max_Path) As Long
   If Debug Then Txt.Print FuncName$
   Local Buffer$
   Tcp Open "HTTP" At "www.garybeene.com" As #1 TimeOut 60000
   Tcp Print #1, "HEAD  " + URL + "  HTTP/1.0"
   Tcp Print #1, ""
   Tcp Recv #1, 4096, Buffer$
   Tcp Close #1
   If InStr( Parse$(Buffer$,$CrLf,1), "OK") Then Function = 1
End Function

Function MoveBarUpDown As Long
   If Debug Then Txt.Print FuncName$
   'returns true if mouse moved vertically while button was down over the horizontal bar
   Local pt As Point, h As Long, w As Long
   Static oldY As Long
   Dialog Get Client hDlg To w,h
   GetCursorPos pt               'pt has xy screen coordinates
   ScreenToClient hDlg, pt       'pt now has client coordinates
   VBarTop = Max(75,Pt.y-3)
   If pt.y <> oldY Then Function = %True : oldY = pt.y
End Function

Sub ResizeWindow(Flag As Long)
   If Debug Then Txt.Print FuncName$
   Local w,h,M,T,VTop As Long
   Dialog Get Client hDlg To w,h

   M = 5  'margin around controls
   T = 6  'splitter thickness (smallest dimension)
   VTop = VBarTop      'VTop will be position of horizontal bar

   'splitterbar colors - change colors when move is in work
   Control Set Color hDlg, %IDC_Splitter, %Black, IIf(SplitVInWork,%Gray,%Red)

   'resize splitterbars
   If Flag Or SplitVInWork Then
      Control Set Size hDlg, %IDC_Splitter, w - M - 5, T
      Control Set Loc hDlg, %IDC_Splitter, M, VTop
   End If

   If Flag Then
      ListView Set Column hDlg, %IDC_ListView, 4, 100
      Control Set Size hDlg, %IDC_ListView, 225, VTop - 70
      Control Set Size hDlg, %IDC_TreeView, 250, VTop - 70
      Control Set Size hDlg, %IDC_Graphic,  w - 515, VTop - 70
      Control Set Size hDlg, %IDC_RichEdit, w - 515, VTop - 70

      Control Set Loc hDlg, %IDC_Browser, 10, VTop + 15
      Control Set Size hDlg, %IDC_Browser, w-20, h - VTop - 25

      Control Set Loc hDlg, %IDC_RichEdit, 10, VTop + 15
      Control Set Size hDlg, %IDC_RichEdit, w-20, h - VTop - 25

      Control Set Loc hDlg, %IDC_Graphic, 10, VTop + 15
      Control Set Size hDlg, %IDC_Graphic, w-20, h - VTop - 25
'      Dialog ReDraw hDlg
   End If

End Sub

Sub CreateContextMenus
    If Debug Then Txt.Print FuncName$
    Menu New PopUp To hPopupListView
    Menu Add String, hPopupListView, "Clear",  %IDM_ClearListView,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Reload",  %IDM_LoadListView,  %MF_Enabled
End Sub

Sub SetControlFonts
   Control Set Font hDlg, %IDC_ListView, hFont
   Control Set Font hDlg, %IDC_TreeView, hFont
   Control Set Font hDlg, %IDC_Toolbar, hFont
End Sub

Sub CreateListVIew
   Control Add ListView, hDlg, %IDC_ListView,"", 270,60,225,100, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_Left Or %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Insert Column hDlg, %IDC_ListView, 1, "Name", 150, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Ext", 70, 0
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer Or %LVS_Ex_CheckBoxes
End Sub

Sub DestroyOCX
   UnregisterClass ("AtlAxWin", GetModuleHandle(ByVal %NULL))
   Set oOcx = Nothing
End Sub

Sub CreateTreeView
   Local hImageList,hItem,hTemp As Dword
   Control Add Treeview, hDlg, %IDC_TreeView, "", 10,60,100,100, %TVS_TrackSelect Or %TVS_HasLines Or %TVS_HasButtons Or %TVS_LinesAtRoot _
       Or %TVS_ShowSelAlways Or %WS_TabStop Or %TVS_EditLabels, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles
   'create imagelist  w,h,depth,size
   ImageList New Icon 16,16,24,3 To hImageList
   ImageList Add Icon hImageList, "xfolder"
   ImageList Add Icon hImageList, "xfile"
   'attach imagelist
   Treeview Set ImageList hDlg, %IDC_TreeView, hImageList
   'build treeview content
   Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 1,1,"c:\" To hItem
   Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 1,4,"n/a" To hItem
   Treeview Get Root hDlg, %IDC_TreeView To hItem
   DisplayChildren hItem
   Treeview Set Expanded hDlg, %IDC_TreeView, hItem, %True
End Sub

Sub CreateOCX
   Local style&, pUnk As Dword, OcxName As AsciiZ * 255, vVar As Variant
   OcxName = "Shell.Explorer"
   AtlAxWinInit
   Control Add "AtlAxWin", hDlg, %IDC_Browser, OcxName, 10, 200, 200,200, %WS_Border Or %WS_Visible Or %WS_Child
   Control Handle hDlg, %IDC_Browser To hOCX
   AtlAxGetControl(hOcx, pUnk)
   AtlMakeDispatch(pUnk, vVar)
   Set oOcx = vVar
End Sub

Sub CreateGraphicControls
   If Debug Then Txt.Print FuncName$
   Control Add Graphic, hDlg, %IDC_Graphic,  "", 10, 200,200,200, %WS_Border
   Graphic Attach hDlg, %IDC_Graphic : Graphic Render Bitmap "xface", (0,0)-(99,99)
End Sub

Sub CreateRichEditControl
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %ES_WantReturn Or %WS_TabStop  Or %WS_ClipSiblings Or %ES_ReadOnly Or %WS_HScroll Or %WS_VScroll
   LoadLibrary("riched32.dll") : InitCommonControls
   Control Add "RichEdit", hDlg, %IDC_RichEdit, "",10,200,200,200, style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
End Sub

Sub AtlMakeDispatch ( ByVal lpObj As Dword, ByRef vObj As Variant) Export
   If Debug Then Txt.Print FuncName$
   Local lpvObj As VARIANTAPI Ptr                 ' Pointer to a VARIANTAPI structure
   Let vObj = Empty                               ' Make sure is empty to avoid memory leaks
   lpvObj = VarPtr(vObj)                          ' Get the VARIANT address
   @lpvObj.vt = %VT_Dispatch                      ' Mark it as containing a dispatch variable
   @lpvObj.pdispVal = lpObj                    ' Set the dispatch pointer address
End Sub

Sub SelectFile
    If Debug Then Txt.Print FuncName$
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "Text/Image Files" + $Nul + TextFilter + ImageFilter + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then LoadFile
    PostMessage GetDlgItem(hDlg, %IDC_RichEdit), %EM_SETSEL, -1, 0   'remove highlighting on cancel load
End Sub

Sub DisplayFindDialog()
   If Debug Then Txt.Print FuncName$
   Local h As Long, w As Long
   Dialog Get Client hDlg To h,w
   Dialog New Pixels, hDlg, "Search", 100, 100, 330, 75, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
   Dialog Set Icon hSearch, "aainfo"

   Control Add CheckBox, hSearch, %IDS_SearchSensitive, "Case Sensitive", 20,45,100,20
   SetMenusAndToolbar

   Control Add Label, hSearch, %IDS_Label, "Find This:", 5, 10, 60, 20
   Control Add TextBox, hSearch, %IDS_SearchTerm, SearchTerm, 60, 10, 185, 20

   Control Add ImgButton, hSearch, %IDS_Forward, "downhand", 260, 10, 25, 25
   Control Add ImgButton, hSearch, %IDS_Backward, "uphand", 295, 10, 25, 25

   Control Add Button, hSearch, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hSearch, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hSearch, %IdOk, %SW_Hide
   Control Show State hSearch, %IdCancel, %SW_Hide

   Dialog Show Modeless hSearch Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop While IsWindow(hSearch)

End Sub

CallBack Function SearchProc() As Long
   Local iCheck&, x As Long, y As Long
   Select Case Cb.Msg
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            Control Set Focus hDlg, %IDC_RichEdit
         End If
      Case %IdCancel
         Dialog End hSearch
      Case %WM_Destroy
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel
               Dialog End hSearch
            Case %IDS_Forward, %IdOk    'search forward
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm
               FindSearchTerm 1  '1 = forward
            Case %IDS_Backward    'search backward
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm
               FindSearchTerm 0  '0 = backward
            Case %IDS_SearchSensitive
               CaseSensitive = CaseSensitive Xor 1
               SetMenusAndToolbar
         End Select
   End Select
End Function

Sub FindSearchTerm(Flag As Long)  '1=forward 0=backward
   If Debug Then Txt.Print FuncName$
   Local temp$, StartPos, EndPos, iPos As Long, sTerm As String
   SendMessage hRichEdit, %EM_GetSel, VarPtr(StartPos), VarPtr(EndPos)  'cursor is here

   Control Get Text hDlg, %IDC_RichEdit To temp$
   sTerm = SearchTerm

   If CaseSensitive = 0 Then temp$ = LCase$(temp$) : sTerm = LCase$(sTerm)

   If Flag Then
      iPos = InStr(EndPos+1, temp$, sTerm)
   Else
      iPos = InStr(StartPos - Len(temp$), temp$, sTerm)
   End If

   If iPos Then
         iPos = SendMessage(hRichEdit, %EM_SetSel, iPos-1, iPos-1 + Len(sTerm))
         SendMessage hRichEdit, %EM_SCROLLCARET, 0, 0
   Else
      Beep
   End If
End Sub

Sub LoadFile
   If Debug Then Txt.Print FuncName$
End Sub

Sub Savefile
   If Debug Then Txt.Print FuncName$
End Sub

Sub SelectFolder
   If Debug Then Txt.Print FuncName$
   Local title$, start$, flags&, folder$, sfolder$
   sFolder$ = PathName$(Path, FileName)
   title$ = "Select Starting Folder for Search"
   start$ = sFolder$
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then LoadFile
End Sub

Sub ManageSystemTray
   If Debug Then Txt.Print FuncName$
   If SysTray Then
      Dialog Show State hDlg, %SW_Hide
      tn.cbsize = SizeOf(tn)
      tn.hwnd   = hDlg
      tn.uid    =  GetModuleHandle(ByVal %NULL)   'g_hinst
      tn.uflags = %nif_icon Or %nif_message Or %nif_tip
      tn.ucallbackmessage = %WM_Tray
      tn.hicon = loadicon(GetModuleHandle(""),"logo" )
      tn.sztip = "gbLittleTemplate"
      Shell_NotifyIcon %nim_add, tn
   Else
      Shell_NotifyIcon %nim_delete, tn
      Dialog Show State hDlg, %SW_Show  ' or %SW_Minimize
   End If
End Sub

Function InstanceTest() As Long
   If Debug Then Txt.Print FuncName$
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As WStringZ * %Max_Path, hWin As Dword
   UniqueName = "gbLittleTemplate"                     'name of mutex
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 Or GetLastError = %ERROR_ALREADY_EXISTS Then
      hWin = GeTTopWindow(%HWND_Desktop)
      Do While hWin
         If GetWindowLong(hWin, %GWL_UserData) = %UniqueNumber Then
            Function = hWin
            Exit Do
         End If
         hWin = GetWindow(hWin, %GW_HWNDNEXT)
      Loop
      ShowWindow(hWin, %SW_Restore)
      ShowWindow(hWin, %SW_Show)
      SetForegroundWindow(hWin)
      Function = 1
   End If
End Function

Sub InitializeTray
   If Debug Then Txt.Print FuncName$
    SetWindowLong(hDlg, %GWL_USERDATA, %UniqueNumber)
    Menu New PopUp To hPopupTray
    Menu Add String, hPopupTray, "Restore",  %IDM_ExitTray,  %MF_Enabled
    Menu Add String, hPopupTray, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupTray, "Exit Tray",  %IDM_ExitTray,  %MF_Enabled
End Sub

Sub CheckAll(Flag As Long)
   If Debug Then Txt.Print FuncName$
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView_SetCheckState hListView, i-1, Flag
   Next i
End Sub

Sub SaveAsText
   If Debug Then Txt.Print FuncName$
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, iResult&, temp$
    ListView Get Select hDlg, %IDC_ListView To iResult&  'SaveAs saves selected history item - no selection, no save
    If iResult& = 0 Then Exit Sub
    title$ = ""                'caption title. if "", then "Save As" is displayed
    startfolder$ = FileName    'initial folder to be displayed
    filter$ = "Text Files" + $Nul + ".txt" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = FileName      'name to be used as initial selection
    defaultext$ = "txt"        'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Control Get Text hDlg, %IDC_RichEdit To temp$
       Open filevar$ For Output As #1
       Print #1, temp$;
       Close #1
    End If
End Sub

Sub NotUsed
   Local hItem, hTemp As Dword
   If 0 Then
      'sample data, not used
      'add items  hdlg,id&,hPrnt,hIAftr,image&,selimage&,txt$ To hItem
      Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 1,1,"One" To hItem
      Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 2,2,"One-1" To hTemp
      Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 2,2,"One-2" To hTemp
      Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 1,1,"Two" To hItem
      Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 2,2,"Two-1" To hTemp
      Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 2,2,"Two-2" To hTemp
   End If
End Sub

Function FullTreePath(ByVal hNode As Dword) As String
   'get full directory path for hNode
   Local hRoot As Dword
   Local FullPath, temp As String
   Do
      Treeview Get Text hDlg, %IDC_TreeView, hNode To temp
      FullPath = "\" + temp + FullPath
      Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
   Loop Until hNode = 0
   Replace "\\" With "\" In FullPath
   Function = LTrim$(FullPath, "\")
End Function

Sub DisplayChildren (hParent As Dword)
   Local hChild, hTemp As Dword
   Local ChildDIR, ParentDIR, temp As String
   Local FullPath As String

   'get text of parent node that is is expanding
   Treeview Get Text hDlg, %IDC_TreeView, hParent To ParentDIR
   ParentDIR = Trim$(ParentDIR, "\")           'this turns c:\ into c:

   'remove all children to ensure currency of display and directory structure
   Do
      Treeview Get Child hDlg, %IDC_TreeView, hParent To hChild
      If hChild Then Treeview Delete hDlg, %IDC_TreeView, hChild
   Loop While hChild

   'add nodes for each subfolder
   ChildDir = Dir$(FullTreePath(hParent) + "\*.*", Only %SubDir)
   While Len(ChildDIR)
      Treeview Insert Item hDlg, %IDC_TreeView, hParent, %TVI_Last, 0, 0, ChildDIR To hTemp
      ChildDIR = Dir$
   Wend

   'add dummy child to each tree element whose folder has subfolders (causes TreeView to display + sign)
   Treeview Get Child hDlg, %IDC_TreeView, hParent To hChild
   While hChild
      FullPath = FullTreePath(hChild)
      temp = Dir$(FullPath + "\*.*", Only %SubDir)
      If Len(temp) Then Treeview Insert Item hDlg, %IDC_TreeView, hChild, %TVI_Last, 0, 0, "n/a" To hTemp
      Treeview Get Next hDlg, %IDC_TreeView, hChild To hChild
   Wend
End Sub

Sub DisplayFilesInListView
   Local temp As String, iCount As Long, hNode As Dword
   ListView Reset hDlg, %IDC_ListView
   Treeview Get Select hDlg, %IDC_Treeview To hNode
   temp = Dir$(FullTreePath(hNode)+"\*.*")
   If Len(temp) Then ListBox Reset hDlg, %IDC_ListView
   Do While Len(temp)
      Incr iCount
      ListView Insert Item hDlg, %IDC_ListView, iCount, 0, PathName$(Name,temp)
      ListView Set Text hDlg, %IDC_ListView, iCount, 2, LCase$(PathName$(Extn,temp))
      temp = Dir$
   Loop
End Sub

Function FileExtension() As Long
   Local iResult As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iResult
   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
   If InStr(TextFilter, temp$) Then Function = %TextFile : Exit Function
   If InStr(ImageFilter, temp$) Then Function = %ImageFile : Exit Function
   If InStr(HTMLFilter, temp$) Then Function = %HTMLFile : Exit Function
   Function = %OtherFile
End Function

Sub ShowSelectedFile
   Local iResult As Long, temp$, fName$, extn$, hNode As Dword

   Treeview Get Select hDlg, %IDC_TreeView To hNode
   temp$ = FullTreePath(hNode)
   ListView Get Select hDlg, %IDC_ListView To iResult
   ListView Get Text hDlg, %IDC_ListView, iResult, 1 To fName$
   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To extn$
   temp$ = temp$ + fName$ + extn$

   Select Case FileExtension
      Case %TextFile
         Control Show State hDlg, %IDC_RichEdit, %SW_Show
         Control Show State hDlg, %IDC_Graphic, %SW_Hide
         Control Show State hDlg, %IDC_Browser, %SW_Hide
         ShowText temp$
      Case %ImageFile
         Control Show State hDlg, %IDC_Graphic, %SW_Show
         Control Show State hDlg, %IDC_RichEdit, %SW_Hide
         Control Show State hDlg, %IDC_Browser, %SW_Hide
         ShowImage temp$
      Case %HTMLFile
         Control Show State hDlg, %IDC_Graphic, %SW_Show
         Control Show State hDlg, %IDC_RichEdit, %SW_Hide
         Control Show State hDlg, %IDC_Browser, %SW_Hide
         ShowHTML temp$
      Case %OtherFile
         Control Show State hDlg, %IDC_Graphic, %SW_Hide
         Control Show State hDlg, %IDC_RichEdit, %SW_Hide
         Control Show State hDlg, %IDC_Browser, %SW_Hide
         ShowNothing temp$
   End Select
End Sub

Sub ShowText(fName$)
   Control Set Text hDlg, %IDC_RichEdit, FileText(fName$)
End Sub

Sub ShowImage(fPath$)
End Sub

Sub ShowHTML(fPath$)
End Sub

Sub ShowNothing(fPath$)
   'display "Unable to display selected file type!"
End Sub

Function FileText(fName$) As String
   Local temp$
   If IsFalse(IsFile(fName$)) Then Exit Function
   Open fName$ For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Function = temp$
End Function
